
subroutine init_linear_wave

!
! initialization for parameterized large-scale linear wave dynamics
use vars
use params
implicit none
integer i,k
real zz(nzm)

   t_wave_local=0.
   q_wave_local=0.
   t_wave=0.
   q_wave=0.
   w_wave=0.
   t_wavebg=0.
   q_wavebg=0.
   t_wavebg_dble=0.
   q_wavebg_dble=0.

   ! jinie
    t_wavebg_adv=0.  
    q_wavebg_adv=0.  
    dt_conv_local=0.
    dt_conv=0.
    F_zeta=0.
    F_t=0.
    F_Q=0.
    w_wave_advzeta=0.
    w_wave_advT=0.
    w_wave_Q=0.
    w_wave_bc=0.

!--------load bg snd, jinie
if (dosobelwtg.and.doloadbgsnd) then
open(77,file=trim(case)//'/snd_bg',status='old',form='formatted')
do k=1,nzm
    read(77,*) t_wavebg(k),q_wavebg(k)
    q_wavebg(k)=q_wavebg(k)/1000.
enddo
close(77)

open(78,file='./'//trim(case)//'/snd_bg_adv',status='old',form='formatted')
do k=1,nzm
    read(78,*) t_wavebg_adv(k),q_wavebg_adv(k)
    q_wavebg_adv(k)=q_wavebg_adv(k)/1000.
enddo
close(78)

!if (masterproc) then
!write(6,*) 'snd_bg for linear wave'
!do k=1,nzm
!    write(6,*) t_wavebg(k),q_wavebg(k)
!enddo
!write(6,*) 'snd_bg_adv for linear wave adv'
!do k=1,nzm
!    write(6,*) t_wavebg_adv(k),q_wavebg_adv(k)
!enddo
!endif

endif

!--------load qgw forcing et., jinie
if (doqgw) then


!---load residual heating term
  open(80,file='./'//trim(case)//'/residual.qgw',status='old',form='formatted')
  if(masterproc) print*,'load residual.qgw'
  do i=1,nzm
      read(80,*) res_qgw(i)
  enddo
  close(80)
  res_qgw=res_qgw/86400.   ! K/day to K/s

!---load forcing 
!  advt/advr are tabs/q advective forcing,   
! advr and lsf q forcing has the same effects
! advt can force qgw, while lsf t forcing does not.
  open(79,file='./'//trim(case)//'/forcing.qgw',status='old',form='formatted')
  if(masterproc) print*,'load forcing.qgw'
  read(79,*)
  read(79,*)
  nt_forcing=1
  do while(.true.)
    read(79,err=55,end=55,fmt=*) time_forcing(nt_forcing), w_bc_all(nt_forcing)
    do i=1,nzm
      read(79,*)  zz(i),advt_all(nt_forcing,i),advr_all(nt_forcing,i),advzeta_all(nt_forcing,i)
      if ( abs(zz(i)-z(i))>1. ) then
        if(masterproc) print*,'in forcing.qgw:',i,zz(i),z(i) 
        if(masterproc) print*,'vertical corrdinate not consistant in sounding and forcing'
            stop
           endif
        enddo
        nt_forcing=nt_forcing+1  
  enddo 
  55 continue
  close(79)
  nt_forcing=nt_forcing-1  

  advt_all=advt_all/86400  ! K/day -> K/s
  advr_all=advr_all/86400*1.e-3  ! g/kg/day -> kg/kg/s
  advzeta_all=advzeta_all/86400.*1.e-6   ! 1e-6/s/day -> /s/s 
!  w_bc_all  ! m/s  

endif








end subroutine init_linear_wave
