!Add vertical advection of q,w due to the large-scale wave and some largescale damping of T, q
subroutine wavesubsidence()
	
use vars
use microphysics
use module_linearwave
implicit none

integer i,j,k
real ttend_center(nzm), qtend_center(nzm) !cell center tendencies

if(nstep.gt.nstartlinearwave+nsteplinearwavebg.and.icycle.eq.ncycle) then

      ttend_center=0.
      qtend_center=0.

      !advect the background/reference T,q fields
        ! jinie
      if(doloadbgsnd.and.doadvectbg==3) then
         !advect T,q from input file
         call linearwavesubsidence2(           w_wave(1:nzm-1),      &
              t_wavebg_adv(1:nzm-1),         q_wavebg_adv(1:nzm-1),    &
              z(1:nzm-1),                          ttend_center(1:nzm-1), &
              qtend_center(1:nzm-1),                           nzm-1 )
      else if (doadvectbg==2) then
         !advect T,q averaged during nsteplinearwavebg period 
        call linearwavesubsidence2(           w_wave(1:nzm-1),      &
              t_wavebg(1:nzm-1),         q_wavebg(1:nzm-1),    &
              z(1:nzm-1),                          ttend_center(1:nzm-1), &
              qtend_center(1:nzm-1),                           nzm-1 )
      else 
         !advect the full T,q
         call linearwavesubsidence2(           w_wave(1:nzm-1),      &
              t_wave(1:nzm-1),                       q_wave(1:nzm-1),    &
              z(1:nzm-1),                          ttend_center(1:nzm-1),&
              qtend_center(1:nzm-1),                           nzm-1 )
      end if


      !apply large-scale tendency of T and q due to w
	if (dosobelwtg.or.doqgw) then      ! jinie  
      do k=1,nzm
         do j=1,ny
            do i=1,nx
               t(i,j,k) = t(i,j,k) + dt * ttend_center(k)                 
               micro_field(i,j,k,index_water_vapor)=micro_field(i,j,k,index_water_vapor) + dt * qtend_center(k)
               micro_field(i,j,k,index_water_vapor) = max(0.,micro_field(i,j,k,index_water_vapor))
            end do
         end do
      end do

  	else if (dokuangdgw)  then
      !apply large-scale damping of T and q
      do k=1,nzm
         do j=1,ny
            do i=1,nx
               t(i,j,k) = t(i,j,k) + dt * (   ttend_center(k) -  (t_wave(k)-t_wavebg(k))/86400./wavetdampingtime   )  
               micro_field(i,j,k,index_water_vapor)=micro_field(i,j,k,index_water_vapor) + dt * (qtend_center(k)-(q_wave(k)-q_wavebg(k))/86400./waveqdampingtime)
               micro_field(i,j,k,index_water_vapor) = max(0.,micro_field(i,j,k,index_water_vapor))
            end do
         end do
      end do
	
	endif
            

   !record the tendencies for output statistics
      ttend_wave = ttend_center
      qtend_wave = qtend_center

! add advection to t and q
   do k=1,nzm
    do j=1,ny
     do i=1,nx
      t(i,j,k)=t(i,j,k)+advt(k) * dt
      micro_field(i,j,k,index_water_vapor) = &
                 max(0.,micro_field(i,j,k,index_water_vapor) + advr(k) * dt)
     end do
    end do
   end do


endif

end
